using System;
using System.Threading;
using Microwave.Classes.Boundary;
using Microwave.Classes.Controllers;
using Timer = Microwave.Classes.Boundary.Timer;

namespace Microwave.App
{
    class Program
    {
        static void Main(string[] args)
        {
            Button startCancelButton = new Button();
            Button powerButton = new Button();
            Button timeButton = new Button();
            Button defrostButton = new Button();

            Door door = new Door();

            Output output = new Output();

            Display display = new Display(output);

            PowerTube powerTube = new PowerTube(output,1000);

            Light light = new Light(output);

            Timer timer = new Timer();

            Buzzer buzzer = new Buzzer();

            CookController cooker = new CookController(timer, display, powerTube);

            UserInterface ui = new UserInterface(powerButton, timeButton, startCancelButton, defrostButton, door, display, light, buzzer, cooker);

            // Finish the double association
            cooker.UI = ui;

            // Simulate a simple sequence
            var test =powerTube.PowerTubeSize;
            var test1 = cooker.MaxPower;

            var powerButtonPresses = 20;

            for (int i = 0; i < powerButtonPresses; i++)
            {
                powerButton.Press();
            }

            defrostButton.Press();

            timeButton.Press();

            startCancelButton.Press();

            // The simple sequence should now run

            System.Console.WriteLine("press 's' to stop program or 't' to extend the cooking time");

            char key = '0';
            while (key != 's')
            {
                key = System.Console.ReadKey().KeyChar;

                if(key == 't')
                    timeButton.Press();
            }



        }
    }
}
