﻿using System;
using System.IO;
using System.Media;
using System.Threading;
using Microwave.Classes.Interfaces;

namespace Microwave.Classes.Boundary
{
    public class Buzzer : IBuzzer
    {
        public void Buzz(int numberOfBursts, int burstDurationMs, string soundFileName)
        {
            var soundFilePath = Path.Combine(Directory.GetCurrentDirectory(), "Sounds", soundFileName);

            if (!File.Exists(soundFilePath))
            {
                throw new FileNotFoundException($"Sound file not found: {soundFilePath}");
            }

            using var player = new SoundPlayer(soundFilePath);

            for (int i = 0; i < numberOfBursts; i++)
            {
                player.Play();
                Thread.Sleep(burstDurationMs);
            }
        }
        public void BuzzToConsole(int numberOfBursts, int burstDurationMs)
        {
            for (int i = 0; i < numberOfBursts; i++)
            {
                Console.WriteLine("Buzz");
                Thread.Sleep(burstDurationMs);
            }
        }
    }
}